## RygelConfiguration

RygelConfiguration — Interface for dealing with Rygel configuration.

## Functions

gboolean | rygel_configuration_get_upnp_enabled ()
gchar * | rygel_configuration_get_interface ()
gchar ** | rygel_configuration_get_interfaces ()
gint | rygel_configuration_get_port ()
gboolean | rygel_configuration_get_transcoding ()
gboolean | rygel_configuration_get_allow_upload ()
gboolean | rygel_configuration_get_allow_deletion ()
gchar * | rygel_configuration_get_log_levels ()
gchar * | rygel_configuration_get_plugin_path ()
gchar * | rygel_configuration_get_engine_path ()
gchar * | rygel_configuration_get_media_engine ()
gchar * | rygel_configuration_get_video_upload_folder ()
gchar * | rygel_configuration_get_music_upload_folder ()
gchar * | rygel_configuration_get_picture_upload_folder ()
gboolean | rygel_configuration_get_enabled ()
gchar * | rygel_configuration_get_title ()
gchar * | rygel_configuration_get_string ()
GeeArrayList * | rygel_configuration_get_string_list ()
gint | rygel_configuration_get_int ()
GeeArrayList * | rygel_configuration_get_int_list ()
gboolean | rygel_configuration_get_bool ()

## Signals

void | configuration-changed | Run Last
void | section-changed | Run Last
void | setting-changed | Run Last

## Types and Values

enum | RygelConfigurationEntry
enum | RygelSectionEntry
enum | RygelConfigurationError
| RygelConfiguration
struct | RygelConfigurationIface

## Object Hierarchy

        GEnum
        ├── RygelConfigurationEntry
        ╰── RygelSectionEntry
        GInterface
        ╰── RygelConfiguration

## Prerequisites

RygelConfiguration requires GObject.

## Known Implementations

RygelConfiguration is implemented by RygelBaseConfiguration and RygelMetaConfig.

## Description

## Functions

### rygel_configuration_get_upnp_enabled ()

    gboolean
    rygel_configuration_get_upnp_enabled (RygelConfiguration *self,
                                          GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_interface ()

    gchar *
    rygel_configuration_get_interface (RygelConfiguration *self,
                                       GError **error);

`rygel_configuration_get_interface` has been deprecated since version 0.19.2 and should not be used in newly-written code.

Replaced by `rygel_configuration_get_interfaces()`.

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_interfaces ()

    gchar **
    rygel_configuration_get_interfaces (RygelConfiguration *self,
                                        GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

#### Returns

.

[array length=result_length1]

### rygel_configuration_get_port ()

    gint
    rygel_configuration_get_port (RygelConfiguration *self,
                                  GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_transcoding ()

    gboolean
    rygel_configuration_get_transcoding (RygelConfiguration *self,
                                         GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_allow_upload ()

    gboolean
    rygel_configuration_get_allow_upload (RygelConfiguration *self,
                                          GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_allow_deletion ()

    gboolean
    rygel_configuration_get_allow_deletion
                                   (RygelConfiguration *self,
                                    GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_log_levels ()

    gchar *
    rygel_configuration_get_log_levels (RygelConfiguration *self,
                                        GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_plugin_path ()

    gchar *
    rygel_configuration_get_plugin_path (RygelConfiguration *self,
                                         GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_engine_path ()

    gchar *
    rygel_configuration_get_engine_path (RygelConfiguration *self,
                                         GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_media_engine ()

    gchar *
    rygel_configuration_get_media_engine (RygelConfiguration *self,
                                          GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_video_upload_folder ()

    gchar *
    rygel_configuration_get_video_upload_folder
                                   (RygelConfiguration *self,
                                    GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_music_upload_folder ()

    gchar *
    rygel_configuration_get_music_upload_folder
                                   (RygelConfiguration *self,
                                    GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_picture_upload_folder ()

    gchar *
    rygel_configuration_get_picture_upload_folder
                                   (RygelConfiguration *self,
                                    GError **error);

#### Parameters

self | the RygelConfiguration instance |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_enabled ()

    gboolean
    rygel_configuration_get_enabled (RygelConfiguration *self,
                                     const gchar *section,
                                     GError **error);

#### Parameters

self | the RygelConfiguration instance |
section |  |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_title ()

    gchar *
    rygel_configuration_get_title (RygelConfiguration *self,
                                   const gchar *section,
                                   GError **error);

#### Parameters

self | the RygelConfiguration instance |
section |  |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_string ()

    gchar *
    rygel_configuration_get_string (RygelConfiguration *self,
                                    const gchar *section,
                                    const gchar *key,
                                    GError **error);

#### Parameters

self | the RygelConfiguration instance |
section |  |
key |  |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_string_list ()

    GeeArrayList *
    rygel_configuration_get_string_list (RygelConfiguration *self,
                                         const gchar *section,
                                         const gchar *key,
                                         GError **error);

#### Parameters

self | the RygelConfiguration instance |
section |  |
key |  |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_int ()

    gint
    rygel_configuration_get_int (RygelConfiguration *self,
                                 const gchar *section,
                                 const gchar *key,
                                 gint min,
                                 gint max,
                                 GError **error);

#### Parameters

self | the RygelConfiguration instance |
section |  |
key |  |
min |  |
max |  |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_int_list ()

    GeeArrayList *
    rygel_configuration_get_int_list (RygelConfiguration *self,
                                      const gchar *section,
                                      const gchar *key,
                                      GError **error);

#### Parameters

self | the RygelConfiguration instance |
section |  |
key |  |
error | location to store the error occuring, or `NULL` to ignore |

### rygel_configuration_get_bool ()

    gboolean
    rygel_configuration_get_bool (RygelConfiguration *self,
                                  const gchar *section,
                                  const gchar *key,
                                  GError **error);

#### Parameters

self | the RygelConfiguration instance |
section |  |
key |  |
error | location to store the error occuring, or `NULL` to ignore |

## Types and Values

### enum RygelConfigurationEntry

#### Members

RYGEL_CONFIGURATION_ENTRY_UPNP_ENABLED |  |
RYGEL_CONFIGURATION_ENTRY_INTERFACE |  |
RYGEL_CONFIGURATION_ENTRY_PORT |  |
RYGEL_CONFIGURATION_ENTRY_TRANSCODING |  |
RYGEL_CONFIGURATION_ENTRY_ALLOW_UPLOAD |  |
RYGEL_CONFIGURATION_ENTRY_ALLOW_DELETION |  |
RYGEL_CONFIGURATION_ENTRY_LOG_LEVELS |  |
RYGEL_CONFIGURATION_ENTRY_PLUGIN_PATH |  |
RYGEL_CONFIGURATION_ENTRY_VIDEO_UPLOAD_FOLDER |  |
RYGEL_CONFIGURATION_ENTRY_MUSIC_UPLOAD_FOLDER |  |
RYGEL_CONFIGURATION_ENTRY_PICTURE_UPLOAD_FOLDER |  |

### enum RygelSectionEntry

#### Members

RYGEL_SECTION_ENTRY_TITLE |  |
RYGEL_SECTION_ENTRY_ENABLED |  |

### enum RygelConfigurationError

#### Members

RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET |  |
RYGEL_CONFIGURATION_ERROR_VALUE_OUT_OF_RANGE |  |

### RygelConfiguration

    typedef struct _RygelConfiguration RygelConfiguration;

Interface for dealing with Rygel configuration.

### struct RygelConfigurationIface

    struct RygelConfigurationIface {
    	GTypeInterface parent_iface;
    	gboolean (*get_upnp_enabled) (RygelConfiguration* self, GError** error);
    	gchar* (*get_interface) (RygelConfiguration* self, GError** error);
    	gchar** (*get_interfaces) (RygelConfiguration* self, GError** error);
    	gint (*get_port) (RygelConfiguration* self, GError** error);
    	gboolean (*get_transcoding) (RygelConfiguration* self, GError** error);
    	gboolean (*get_allow_upload) (RygelConfiguration* self, GError** error);
    	gboolean (*get_allow_deletion) (RygelConfiguration* self, GError** error);
    	gchar* (*get_log_levels) (RygelConfiguration* self, GError** error);
    	gchar* (*get_plugin_path) (RygelConfiguration* self, GError** error);
    	gchar* (*get_engine_path) (RygelConfiguration* self, GError** error);
    	gchar* (*get_media_engine) (RygelConfiguration* self, GError** error);
    	gchar* (*get_video_upload_folder) (RygelConfiguration* self, GError** error);
    	gchar* (*get_music_upload_folder) (RygelConfiguration* self, GError** error);
    	gchar* (*get_picture_upload_folder) (RygelConfiguration* self, GError** error);
    	gboolean (*get_enabled) (RygelConfiguration* self, const gchar* section, GError** error);
    	gchar* (*get_title) (RygelConfiguration* self, const gchar* section, GError** error);
    	gchar* (*get_string) (RygelConfiguration* self, const gchar* section, const gchar* key, GError** error);
    	GeeArrayList* (*get_string_list) (RygelConfiguration* self, const gchar* section, const gchar* key, GError** error);
    	gint (*get_int) (RygelConfiguration* self, const gchar* section, const gchar* key, gint min, gint max, GError** error);
    	GeeArrayList* (*get_int_list) (RygelConfiguration* self, const gchar* section, const gchar* key, GError** error);
    	gboolean (*get_bool) (RygelConfiguration* self, const gchar* section, const gchar* key, GError** error);
    };

Interface for creating RygelConfiguration implementations.

#### Members

GTypeInterface `parent_iface`; | the parent interface structure |
`get_upnp_enabled` () | virtual method called by `rygel_configuration_get_upnp_enabled()` |
`get_interface` () | virtual method called by `rygel_configuration_get_interface()` |
`get_interfaces` () | virtual method called by `rygel_configuration_get_interfaces()` |
`get_port` () | virtual method called by `rygel_configuration_get_port()` |
`get_transcoding` () | virtual method called by `rygel_configuration_get_transcoding()` |
`get_allow_upload` () | virtual method called by `rygel_configuration_get_allow_upload()` |
`get_allow_deletion` () | virtual method called by `rygel_configuration_get_allow_deletion()` |
`get_log_levels` () | virtual method called by `rygel_configuration_get_log_levels()` |
`get_plugin_path` () | virtual method called by `rygel_configuration_get_plugin_path()` |
`get_engine_path` () | virtual method called by `rygel_configuration_get_engine_path()` |
`get_media_engine` () | virtual method called by `rygel_configuration_get_media_engine()` |
`get_video_upload_folder` () | virtual method called by `rygel_configuration_get_video_upload_folder()` |
`get_music_upload_folder` () | virtual method called by `rygel_configuration_get_music_upload_folder()` |
`get_picture_upload_folder` () | virtual method called by `rygel_configuration_get_picture_upload_folder()` |
`get_enabled` () | virtual method called by `rygel_configuration_get_enabled()` |
`get_title` () | virtual method called by `rygel_configuration_get_title()` |
`get_string` () | virtual method called by `rygel_configuration_get_string()` |
`get_string_list` () | virtual method called by `rygel_configuration_get_string_list()` |
`get_int` () | virtual method called by `rygel_configuration_get_int()` |
`get_int_list` () | virtual method called by `rygel_configuration_get_int_list()` |
`get_bool` () | virtual method called by `rygel_configuration_get_bool()` |

## Signal Details

### The `“configuration-changed”` signal

    void
    user_function (RygelConfiguration     *configuration,
                   RygelConfigurationEntry entry,
                   gpointer                user_data)

Emitted when any of known configuration settings has changed. RygelConfigurationEntry lists known configuration settings.

#### Parameters

configuration | the RygelConfiguration instance that received the signal |
entry |  |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“section-changed”` signal

    void
    user_function (RygelConfiguration *configuration,
                   gchar              *section,
                   RygelSectionEntry   entry,
                   gpointer            user_data)

Emitted when any of section settings has changed. RygelSectionEntry lists known section settings.

#### Parameters

configuration | the RygelConfiguration instance that received the signal |
section |  |
entry |  |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“setting-changed”` signal

    void
    user_function (RygelConfiguration *configuration,
                   gchar              *section,
                   gchar              *key,
                   gpointer            user_data)

Emitted when some custom setting has changed. That happens when changed setting does fit into neither configuration_changed nor section_changed signal.

#### Parameters

configuration | the RygelConfiguration instance that received the signal |
section |  |
key |  |
user_data | user data set when the signal handler was connected. |

Flags: Run Last